#include	"stdThread.h"
#include	<conio.h>
#include	"SendRecvThread.h"	// MXbhg
#include	"MySyncObject.h"	// IuWFNgg
#include	"define.h"

#define MAX_SOCKET_NUM	(20)	// ҋ@p\Pbg̍ő吔

// ֐̐錾
BOOL InitSocketLib();
BOOL UninitSocketLib();
BOOL CreateAndBindSocket(WORD wPort);	// ڑ҂p\Pbg̍쐬ƖOt
BOOL DestroySocket(SOCKET &fd);			// \Pbg̔j		
void Stop();							// ׂẴ\Pbgj
BOOL CheckKey();						// L[͂̌

// ϐ̐錾
SOCKET	m_fdServer[MAX_SOCKET_NUM];		// bindςUDP\Pbg
int		m_iSockCount;					// bindςUDP\Pbg̐
CSendRecvThread		*m_pCSendRecvThread[MAX_SOCKET_NUM] = { NULL };	//
ConnectionInfoRec	*m_pConInfo[MAX_SOCKET_NUM] = { NULL };			//
CMySyncObject		*m_pCMySyncObject = NULL;

int main(int argc, char *argv[])
{
	int		iRet = -1;
	int		ii;

	Locate(1, 1, 2);
	m_pCMySyncObject = new CMySyncObject();
	m_pCMySyncObject->Initialize();
	// Np[^`FbN
	if (argc != 2)
	{
		fprintf(stderr, "Usage:  %s <Server Port>\n", argv[0]);
		goto L_END;
	}
	// \PbgCȕ
	if (InitSocketLib() == FALSE)
		goto L_END;

	// ϐ̏
	for (ii = 0; ii < MAX_SOCKET_NUM; ++ii)
		m_fdServer[ii] = INVALID_SOCKET;

	// UDP\Pbg̍쐬bind
	// bindς݂̃\Pbgm_fdServer[]Ɋi[
	if (CreateAndBindSocket((WORD)atol(argv[1])) == FALSE)
		goto L_END;

	// bindς݃\Pbgɑ΂đMXbh̍쐬
	for (ii = 0; ii < m_iSockCount; ++ii)
	{
		m_pConInfo[ii] = (ConnectionInfoRec *)calloc(1, sizeof(ConnectionInfoRec));
		m_pConInfo[ii]->pCMySyncObject = m_pCMySyncObject;
		m_pConInfo[ii]->fdClient = m_fdServer[ii];
		m_pCSendRecvThread[ii] = new CSendRecvThread(m_pConInfo[ii]);
		m_pCSendRecvThread[ii]->Begin();
	}
	// L[{[̏ImF
	while (1)
	{
		Sleep(10);				// 10msec҂
		if (CheckKey())
		{
			fprintf(stderr, "  OK:Abort by key\n");
			break;
		}
	}
	iRet = 0;
L_END:
	// ׂẴ\Pbg̔j
	Stop();
	m_pCMySyncObject->Uninitialize();
	SAFE_DELETE(m_pCMySyncObject)
// \PbgCůJ
	UninitSocketLib();
	return(iRet);
}

#define     VERSION_RECESTED    MAKEWORD(2, 0)	// KvƂWINSOCK.DLL(WSOCK32.DLL ̃o[W)
//----------------------------------------------
// function
//    \PbgCũ[h
// parameter
//    Ȃ
// retun
//    Ȃ
//----------------------------------------------
BOOL InitSocketLib()
{
	WORD	wVersionRequested;		// Io[Wi[GA(windows)
	WSADATA	wsaData;			// IWinSock i[GA(windows)
	BOOL	fRet;

	wVersionRequested = VERSION_RECESTED;		// 
	fRet = (WSAStartup(wVersionRequested, &wsaData) == 0) ? TRUE : FALSE;
	return(fRet);
}

//----------------------------------------------
// function
//    \PbgCůJ
// parameter
//    Ȃ
// retun
//    Ȃ
//----------------------------------------------
BOOL UninitSocketLib()
{
	BOOL	fRet;

	fRet = (WSACleanup() == 0) ? TRUE : FALSE;	// 
	return(fRet);
}

//----------------------------------------------
// function
//    Mp\Pbg̍쐬bind̎{
// parameter
//    WORD	wPort	[in]|[gԍ
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL CreateAndBindSocket(WORD wPort)
{
	BOOL	fRet = TRUE;
	struct addrinfo	hints, *pres = NULL, *pTemp = NULL;
	char	szPort[NI_MAXSERV];
	int 	on;

	fprintf(stderr, "CreateAndBindSocket()\n");

	m_iSockCount = 0;
	// f[^O^łׂẴC^[tF[XŎM\ȃAhX̏
	memset(&hints, 0, sizeof(hints));
	hints.ai_socktype = SOCK_DGRAM;			// UDP
	hints.ai_flags = AI_PASSIVE;
	DISABLE_C4996
	sprintf(szPort, "%d", wPort);
	ENABLE_C4996

	if (getaddrinfo(NULL, szPort, &hints, &pres) == 0)
	{
		// Ԃpres̒Ɋi[Ăgp
		pTemp = pres;
		while ((pTemp != NULL) && (m_iSockCount < MAX_SOCKET_NUM))
		{
			// Socket̍쐬, bind̎s
			// \Pbg쐬
			m_fdServer[m_iSockCount] = socket(pTemp->ai_family, pTemp->ai_socktype, pTemp->ai_protocol);
			if (m_fdServer[m_iSockCount] == INVALID_SOCKET)
				goto L_NEXT;
			fprintf(stderr, "%d %d %d %d\n", (int)m_fdServer[m_iSockCount], pTemp->ai_family, AF_INET, AF_INET6);
#ifdef IPV6_V6ONLY
			// IPv6\PbgIPv4ˉeAhXgpȂ悤ɐݒ
			if (pTemp->ai_family == AF_INET6)
			{
				on = 1;
				if (setsockopt(m_fdServer[m_iSockCount], IPPROTO_IPV6, IPV6_V6ONLY, (char *)&on, sizeof(on)) < 0)
				{
					DispErrorMsg("Err:setsockopt");
					goto L_NEXT;
				}
			}
#endif
			// UDPłSO_REUSEADDRgȂ
			// bind̎s
			if (bind(m_fdServer[m_iSockCount], pTemp->ai_addr, (int)pTemp->ai_addrlen) == SOCKET_ERROR)
			{
				// bindɎsÃ\PbgjĎ̃\Pbg̏s
				DispErrorMsg("Err:bind");
				DestroySocket(m_fdServer[m_iSockCount]);
				goto L_NEXT;
			}
			++m_iSockCount;
L_NEXT:
			pTemp = pTemp->ai_next;			// ̏
		}
		freeaddrinfo(pres);
	}
	if (m_iSockCount == 0)					// ЂƂbindłȂƂ͎sԂ
		fRet = FALSE;
	return(fRet);
}


//----------------------------------------------
// function
//    \Pbg̔j
// parameter
//    SOCKET		&fd[in/out]j\Pbg
// return
//    TRUE/FALSE
//----------------------------------------------
BOOL DestroySocket(SOCKET &fd)
{
	if (fd != INVALID_SOCKET)
	{
		fprintf(stderr, "DestroySocket()\n");
		shutdown(fd, SD_BOTH);     // MM~
		closesocket(fd);
		fd = INVALID_SOCKET;
	}
	return(TRUE);
}

//----------------------------------------------
// function
//    \Pbg̔jAMXbh̔j
// parameter
//    Ȃ
// return
//    Ȃ
//----------------------------------------------
void Stop()
{
	int		ii;

	fprintf(stderr, "Stop()\n");
	//MXbh̔j, ڑς݃\Pbg̔j
	for (ii = 0; ii < m_iSockCount; ++ii)
	{
		if (m_pCSendRecvThread[ii] != NULL)
		{
			m_pCSendRecvThread[ii]->End();
			m_pCSendRecvThread[ii]->WaitForEnd();
			SAFE_DELETE(m_pCSendRecvThread[ii]);

			DestroySocket(m_pConInfo[ii]->fdClient);
			SAFE_FREE(m_pConInfo[ii])
		}
	}
}

//----------------------------------------------
// function
//    L[̓`FbN
// parameter
//    Ȃ
// return
//    TRUE:͂
//----------------------------------------------
BOOL CheckKey()
{
	BOOL			fRet = FALSE;

	if (_kbhit())
	{
		_getch();
		fRet = TRUE;
	}
	return(fRet);
}

